<template>
  <div class="product">
    <navigation-bar />
    <div class="product-list">
      <div class="product-box" v-for="product in $store.state.products" :key="product.id" @click="openProductDialog(product)">
        <div class="product-photos">
          <img class="product-photo" :src="product.photos[0]" alt="" />
        </div>
        <div class="product-title">
          {{ product.title }}
        </div>
        <div class="product-tags">
          <div class="product-tag" v-for="(tag, index) in product.tags" :key="index">
            {{ tag }}
          </div>
        </div>
        <div class="cart-box">
          <button class="add-to-cart-btn" @click.stop="addToCart(product)">Add to Cart</button>
        </div>
      </div>
    </div>

    <product-dialog v-if="selectedProduct" :product="selectedProduct" @close="closeProductDialog" />
  </div>
</template>

<script lang="ts">
import { Vue, Component } from "vue-property-decorator";
import { Getter, Action } from 'vuex-class';
import ProductDialog from '@/components/ProductDialog.vue';
import NavigationBar from '@/components/NavigationBar.vue';

@Component({
  components: {
    'product-dialog': ProductDialog,
    'navigation-bar': NavigationBar,
  },
})
export default class Products extends Vue {
  @Getter('getProducts') getProducts!: () => any[];
  @Action('fetchProducts') fetchProducts!: () => Promise<void>;
  @Action('addProductToCart') addProductToCart!: () => void;

  private selectedProduct: any = null;

  private openProductDialog(product: any) {
    this.selectedProduct = product;
  }

  private closeProductDialog() {
    this.selectedProduct = null;
  }

  private addToCart(product: any) {
    this.$store.dispatch('addProductToCart', product);
  }

  mounted() {
    this.fetchProducts();
  }
}
</script>

<style scoped>
.product-list {
  display: flex;
  flex-wrap: wrap;
  justify-content: space-around;
  padding: 20px;
}

.product-box {
  width: 300px;
  background-color: #fff;
  border: 1px solid #ddd;
  border-radius: 8px;
  margin: 10px;
  padding: 15px;
  cursor: pointer;
  box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
  transition: transform 0.3s ease-in-out;
}

.product-title {
  font-size: 18px;
  font-weight: bold;
  margin-bottom: 8px;
}

.product-photos {
  display: flex;
  justify-content: center;
  margin-bottom: 10px;
}

.product-photo {
  max-width: 100%;
  height: auto;
}

.product-tags {
  display: flex;
  flex-wrap: wrap;
}

.product-tag {
  background-color: #eee;
  border-radius: 4px;
  padding: 4px 8px;
  margin-right: 8px;
  margin-bottom: 8px;
  font-size: 12px;
}

.cart-box {
  display: flex;
  justify-content: flex-end
}

.add-to-cart-btn {
  background-color: #4caf50;
  color: #fff;
  border: none;
  padding: 8px 16px;
  border-radius: 4px;
  cursor: pointer;
  transition: background-color 0.3s ease-in-out;
}
</style>